package com.yidianling.dynamic.publishTrend

import android.annotation.SuppressLint
import android.content.Context
import android.content.Intent
import android.os.Build
import android.os.Handler
import android.view.KeyEvent
import android.view.View
import android.view.inputmethod.InputMethodManager
import android.widget.EditText
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.GridLayoutManager
import com.luck.picture.lib.entity.LocalMedia
import com.luck.picture.lib.listener.OnResultCallbackListener
import com.ydl.ydlcommon.actions.imagepicker.YDLImagePicker.startPicker
import com.ydl.ydlcommon.adapter.custom.PublishImageAdapter
import com.ydl.ydlcommon.base.BaseActivity
import com.ydl.ydlcommon.ui.ParcelableImage
import com.ydl.ydlcommon.view.dialog.NormalDialog
import com.yidianling.common.tools.ToastUtil
import com.yidianling.dynamic.R
import com.yidianling.dynamic.bean.DynamicConstants
import com.yidianling.dynamic.common.emoji.IEmoticonSelectedListener
import kotlinx.android.synthetic.main.activity_dynamic_publish_trends.*
import kotlinx.android.synthetic.main.dynamic_layout_publish_trend_bottom.*
import kotlin.collections.ArrayList

class PublishTrendActivityTrends :BaseActivity(), View.OnClickListener, IEmoticonSelectedListener {
    private var adapter: PublishImageAdapter? = null
    private  var publishTrendImgs:ArrayList<ParcelableImage>?=null
    private  var publishTrendImgBrows:ArrayList<ParcelableImage>?=null
    var is_niming = 1 //是否匿名：1否，2匿名
    private var isKeyboardShowed = true // 是否显示键盘
    protected var uiHandler: Handler? = null

    //测试结果页(或者fm页面、文章页面)传过来的数据
    private val Test_url: String? = null
    private val Test_cover: String? = null
    private val Test_title: String? = null
    var topic_id: String? = null
    var topic_title: String? = null
    /**
     * 表情弹窗是否显示
     */
    private var emojilayot_ishow = false
    var writeing_title = false

    /**
     * 仅对专家可见
     * 1仅专家可见 2所有可见
     * 默认所有可见
     */
    private var isDoctorShow = 2
    companion object{
        fun start(context: Context,topic_id:String,topic_title:String) {
            val intent = Intent(context, PublishTrendActivityTrends::class.java)
            intent.putExtra("topic_id", topic_id)
            intent.putExtra("topic_title", topic_title)
            context.startActivity(intent)
        }
    }
    override fun initDataAndEvent() {
        // 从话题详情进来的发布
        topic_id = intent.getStringExtra("topic_id")
        topic_title = intent.getStringExtra("topic_title")
        if (adapter == null) {
            adapter = PublishImageAdapter(publishTrendImgs, this)
        } else {
            adapter!!.notifyDataSetChanged()
        }
        publishTrendImgs = ArrayList()
        publish_trend_img_rcv.setLayoutManager(GridLayoutManager(this, 4))
        publish_trend_img_rcv.setAdapter(adapter)
        publish_trend_img_rcv.setOnClickListener(this)
        publish_trend_bottom_img_iv.setOnClickListener(this)
        publish_trend_bottom_topic_tv.setOnClickListener(this)
        publish_anonymity_rel.setOnClickListener(this)
        publish_emoji_iv.setOnClickListener(this)
        ll_to_expert.setOnClickListener(this)
    }

    override fun layoutResId(): Int {
    return R.layout.activity_dynamic_publish_trends
    }

    override fun onClick(v: View) {
        if (v.getId() == R.id.publish_anonymity_rel) {
            if (is_niming == 1) { //是否匿名：1否，2匿名
                val builder = NormalDialog.Builder(this)
                builder.setTitle("")
                builder.setMessage("设置匿名后，将会隐藏你的个人头像、昵称")
                builder.setPositiveButton(
                    "确定匿名"
                ) { dialog, which ->
                    publish_anonymity_iv.setImageResource(R.drawable.dynamic_checkbox_sel)
                    is_niming = 2
                    dialog.dismiss()
                }
                builder.setNegativeButton(
                    "公开"
                ) { dialog, which -> dialog.dismiss() }
                builder.create().show()
            } else {
                publish_anonymity_iv.setImageResource(R.drawable.dynamic_checkbox)
                is_niming = 1
            }
        } else if (v.getId() == R.id.publish_trend_bottom_img_iv) {
            if ("" == Test_url || Test_url == null || "" == Test_cover || Test_cover == null || "" == Test_title || Test_title == null) {
                if (publishTrendImgs!!.size < 9) {
                    showSelector()
                } else {
                    if ("default" == publishTrendImgs!![8].image_url) {
                        showSelector()
                    } else {
                        ToastUtil.toastShort("最多选择9张照片")
                    }
                }
            }
        } else if (v.getId() == R.id.publish_trend_bottom_topic_tv) {
            val intent = Intent()
            intent.setClass(this, SelecTopicActivity::class.java)
            startActivityForResult(intent, DynamicConstants.REQUEST_CODE_SELECT_TOPIC)
        } else if (v.getId() == R.id.publish_emoji_iv) {
            if (writeing_title == false) {
                toggleEmojiLayout()
            }
        } else if (v.getId() == R.id.ll_to_expert) { //仅对专家可见
            if (isDoctorShow == 1) {
                isDoctorShow = 2
                iv_to_expert.setImageResource(R.drawable.dynamic_checkbox)
            } else {
                isDoctorShow = 1
                iv_to_expert.setImageResource(R.drawable.dynamic_checkbox_sel)
            }
        }
    }
    private fun showSelector() {
        val selectedSize = if (publishTrendImgs!!.size != 0) publishTrendImgs!!.size - 1 else 0
        startPicker(
            (this)!!,
            9 - selectedSize,
            object : OnResultCallbackListener {
                override fun onResult(list: List<LocalMedia>) {
                    if (list.isEmpty()) {
                        return
                    }
                    if (Build.VERSION.SDK_INT > Build.VERSION_CODES.P) {
                        for (i in list.indices) {
                            AddImag(list[i].androidQToPath)
                        }
                    } else {
                        for (i in list.indices) {
                            AddImag(list[i].path)
                        }
                    }
                }

                override fun onCancel() {}
            })
    }

    /**
     * 添加照片
     */
    private fun AddImag(pic_path: String) {
        val trendImage = ParcelableImage(pic_path)
        if (publishTrendImgs!!.size < 9 && publishTrendImgs!!.size > 0) {
            publishTrendImgs!!.add(publishTrendImgs!!.size - 1, trendImage)
        } else if (publishTrendImgs!!.size == 0) {
            publishTrendImgs!!.add(ParcelableImage("default"))
            publishTrendImgs!!.add(publishTrendImgs!!.size - 1, trendImage)
        } else {
            publishTrendImgs!!.removeAt(8)
            publishTrendImgs!!.add(8, trendImage)
        }
        adapter!!.updateDate(publishTrendImgs)
    }

    @SuppressLint("WrongConstant")
    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == RESULT_OK) {
            when (requestCode) {
                DynamicConstants.PUBLISH_PIC_BROW -> {
                    if (data == null) {
                        return
                    }
                    val chane_state = data.getBooleanExtra("chane_state", false)
                    if (chane_state) {
                        val bundle = data.getBundleExtra("bundle")
                        publishTrendImgs = bundle.getParcelableArrayList("publish_img")
                        if ((publishTrendImgs as ArrayList<ParcelableImage>?)?.size!! > 0) {
                            (publishTrendImgs as ArrayList<ParcelableImage>?)?.add(ParcelableImage("default"))
                        }
                        adapter!!.updateDate(publishTrendImgs)
                    }
                }
                DynamicConstants.REQUEST_CODE_SELECT_TOPIC -> {
                    val type = data!!.getStringExtra("type")
                    if ("topic_select" == type) {
                        val bd = data.getBundleExtra("bundle")
                        if (bd != null) {
                            topic_id = bd.getString("topic_id")
                            topic_title = bd.getString("topic_title")
                        }
                        publish_trend_bottom_topic_tv.visibility = View.VISIBLE
                        publish_trend_bottom_topic_tv.text = "# $topic_title"
                        publish_trend_bottom_topic_tv.setTextColor(
                            ContextCompat.getColor(
                                this,
                                R.color.platform_main_theme
                            )
                        )
                        // 获取编辑框焦点
                        publish_trend_content_editext.isFocusable = true
                        hideEmojiLayout()
                        //打开软键盘
                        val imm =
                            this.getSystemService(INPUT_METHOD_SERVICE) as InputMethodManager
                        imm.toggleSoftInput(0, InputMethodManager.HIDE_NOT_ALWAYS)
                    }
                }
            }
        }
    }
    // 点击表情，切换到表情布局
    @SuppressLint("WrongConstant")
    private fun toggleEmojiLayout() {
        if (emoticon_picker_view == null || emoticon_picker_view.visibility == View.GONE) {
            showEmojiLayout()
            //            publish_emoji_iv.setImageResource(R.drawable.dynamic_edict_ico_key);
        } else {
            hideEmojiLayout()
            showInputMethod(publish_trend_content_editext)
            publish_emoji_iv.setImageResource(R.drawable.dynamic_edict_ico_emoji)
        }
    }
    private val showEmojiRunnable =
        Runnable { emoticon_picker_view.visibility = View.VISIBLE }
    private val showTextRunnable = Runnable { showInputMethod(publish_trend_content_editext) }
    // 隐藏表情布局
    @SuppressLint("WrongConstant")
    fun hideEmojiLayout() {
        uiHandler?.removeCallbacks(showEmojiRunnable)
        if (emoticon_picker_view != null) {
            emoticon_picker_view.visibility = View.GONE
        }
        emojilayot_ishow = false
    }
    // 显示表情布局
    @SuppressLint("WrongConstant")
    private fun showEmojiLayout() {
        hideInputMethod()
        publish_trend_content_editext.requestFocus()
        emoticon_picker_view.visibility = View.VISIBLE
        emoticon_picker_view.show(this)
        emojilayot_ishow = true
    }

    // 隐藏键盘布局
    private fun hideInputMethod() {
        isKeyboardShowed = false
        uiHandler?.removeCallbacks(showTextRunnable)
        @SuppressLint("WrongConstant") val imm =
            this.getSystemService(INPUT_METHOD_SERVICE) as InputMethodManager
        imm.hideSoftInputFromWindow(publish_trend_content_editext.windowToken, 0)
        publish_trend_content_editext.clearFocus()
    }

    // 显示键盘布局
    private fun showInputMethod(editTextMessage: EditText) {
        editTextMessage.requestFocus()
        //如果已经显示,则继续操作时不需要把光标定位到最后
        if (!isKeyboardShowed) {
            editTextMessage.setSelection(editTextMessage.text.length)
            isKeyboardShowed = true
        }
        @SuppressLint("WrongConstant") val imm =
            this.getSystemService(INPUT_METHOD_SERVICE) as InputMethodManager
        imm.showSoftInput(editTextMessage, 0)
    }

    override fun onEmojiSelected(key: String?) {
        val mEditable = publish_trend_content_editext.text
        if (key == "/DEL") {
            publish_trend_content_editext.dispatchKeyEvent(
                KeyEvent(
                    KeyEvent.ACTION_DOWN,
                    KeyEvent.KEYCODE_DEL
                )
            )
        } else {
            var start = publish_trend_content_editext.selectionStart
            var end = publish_trend_content_editext.selectionEnd
            start = if (start < 0) 0 else start
            end = if (start < 0) 0 else end
            mEditable.replace(start, end, key)
        }
    }

    override fun onStickerSelected(categoryName: String?, stickerName: String?) {

    }
}